> For the complete documentation index, see [llms.txt](https://docs.2checkout.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.2checkout.com/soap-api-reference/soap-api-6.0/api-requests/update-proposal.md).

# Update proposal

Use the **updateProposal** method via SOAP API 6.0 to update the details of a proposal or quote.

## Request parameters

| Parameters                                                                                                               | Type   | Required/Optional | Description                                                        |
| ------------------------------------------------------------------------------------------------------------------------ | ------ | ----------------- | ------------------------------------------------------------------ |
| **proposalId**                                                                                                           | String | Required          | The unique merchant proposal ID generated by the 2Checkout system. |
| **sessionId**                                                                                                            | String | Required          | Unique 2Checkout session ID code.                                  |
| **Name**                                                                                                                 | String | Optional          | Proposal name.                                                     |
| **UserId**                                                                                                               | String | Optional          | The unique user ID generated by the 2Checkout system.              |
| [**BillTo**](https://verifone.cloud/docs/2checkout/API-Integration/JSON-RPC_API_6.0/API-Requests/Proposal-microservice/) | Object | Optional          | The billing details associated with the proposal.                  |
| [**SellTo**](https://verifone.cloud/docs/2checkout/API-Integration/JSON-RPC_API_6.0/API-Requests/Proposal-microservice/) | Object | Optional          | Represents the entity using the service. Used for tax calculation. |

### Request sample

```php
<?php

require ('PATH_TO_AUTH');

$proposalID = "0573e71d-38bb-4d61-88ca-b3c557517c68";

try {
    $result = $soapClient->getProposalById($sessionID, $proposalID);
    echo "Fetching Proposal ID: {$proposalID} </br>";
}
catch (SoapFault $e) {
    echo "Could not fetch proposal: " . $e->getMessage();
    exit;
}

$result->Name = "Updated proposal name";
$result->UserId = "myuser";
$result->BillTo->FirstName = "Billing Contact first name";
$result->BillTo->LastName = "Billing Contact last name";
$result->BillTo->Email = "contact@email.com";
$result->BillTo->Country = "US";
$result->BillTo->State = "California";
$result->BillTo->vatCode = "85421564";
$result->BillTo->City = "San Francisco";
$result->BillTo->Address = "Street name No. 9 San Francisco, California";
$result->SellTo->FirstName = "Contact first name";
$result->SellTo->LastName = "Contact last name";
$result->SellTo->Email = "contact@email.com";
$result->SellTo->Country = "US";
$result->SellTo->State = "California";
$result->SellTo->City = "San Francisco";
$result->SellTo->Address = "Street name No. 5 San Francisco, California";

try {
    $updateResult = $soapClient->updateProposal($sessionID, $result->ProposalId, $result);
    echo "New proposal created: </br>",
    var_dump($updateResult);
}
catch (SoapFault $e) {
    echo "Could not create proposal: " . $e->getMessage();
    exit;
}
```

### Request sample with prorationDate

```php
<?php

require ('PATH_TO_AUTH');

$proposalID = "0573e71d-38bb-4d61-88ca-b3c557517c68";

try {
    $result = $soapClient->getProposalById($sessionID, $proposalID);
    echo "Fetching Proposal ID: {$proposalID} </br>";
}
catch (SoapFault $e) {
    echo "Could not fetch proposal: " . $e->getMessage();
    exit;
}

$result->Content->LineItems[0]->ProrationData = "2020-11-14T15:28:56+00:00";

try {
    $updateResult = $soapClient->updateProposal($sessionID, $result->ProposalId, $result);
    echo "New proposal created: </br>",
    var_dump($updateResult);
}
catch (SoapFault $e) {
    echo "Could not create proposal: " . $e->getMessage();
    exit;
}
```

### Request sample with vatCode

```php
<?php

require ('PATH_TO_AUTH');

$proposalID = "0573e71d-38bb-4d61-88ca-b3c557517c68";

try {
    $result = $soapClient->getProposalById($sessionID, $proposalID);
    echo "Fetching Proposal ID: {$proposalID} </br>";
}
catch (SoapFault $e) {
    echo "Could not fetch proposal: " . $e->getMessage();
    exit;
}

$result->Name = "Updated proposal name";
$result->UserId = "myuser";
$result->BillTo->FirstName = "Billing Contact first name";
$result->BillTo->LastName = "Billing Contact last name";
$result->BillTo->Email = "contact@email.com";
$result->BillTo->Country = "US";
$result->BillTo->State = "California";
$result->BillTo->City = "San Francisco";
$result->BillTo->Address = "Street name No. 9 San Francisco, California";
$result->SellTo->FirstName = "Contact first name";
$result->SellTo->LastName = "Contact last name";
$result->SellTo->Email = "contact@email.com";
$result->SellTo->Country = "US";
$result->SellTo->State = "California";
$result->SellTo->vatCode = "85421564";
$result->SellTo->City = "San Francisco";
$result->SellTo->Address = "Street name No. 5 San Francisco, California";

try {
    $updateResult = $soapClient->updateProposal($sessionID, $result->ProposalId, $result);
    echo "New proposal created: </br>",
    var_dump($updateResult);
}
catch (SoapFault $e) {
    echo "Could not create proposal: " . $e->getMessage();
    exit;
}
```

### Request sample with TaxExemptionId

```php
<?php

require ('PATH_TO_AUTH');

$proposalID = "0573e71d-38bb-4d61-88ca-b3c557517c68";

try {
    $result = $soapClient->getProposalById($sessionID, $proposalID);
    echo "Fetching Proposal ID: {$proposalID} </br>";
}
catch (SoapFault $e) {
    echo "Could not fetch proposal: " . $e->getMessage();
    exit;
}

$result->Name = "Updated proposal name";
$result->UserId = "myuser";
$result->BillTo->FirstName = "Billing Contact first name";
$result->BillTo->LastName = "Billing Contact last name";
$result->BillTo->Email = "contact@email.com";
$result->BillTo->Country = "US";
$result->BillTo->State = "California";
$result->BillTo->City = "San Francisco";
$result->BillTo->Address = "Street name No. 9 San Francisco, California";
$result->SellTo->FirstName = "Contact first name";
$result->SellTo->LastName = "Contact last name";
$result->SellTo->Email = "contact@email.com";
$result->SellTo->Country = "US";
$result->SellTo->State = "California";
$result->SellTo->TaxExemptionId = "85421564";
$result->SellTo->City = "San Francisco";
$result->SellTo->Address = "Street name No. 5 San Francisco, California";

try {
    $updateResult = $soapClient->updateProposal($sessionID, $result->ProposalId, $result);
    echo "New proposal created: </br>",
    var_dump($updateResult);
}
catch (SoapFault $e) {
    echo "Could not create proposal: " . $e->getMessage();
    exit;
}
```

### Response

The **updateProposal** call via SOAP API 6.0 returns the [Proposal object](https://docs.2checkout.com/soap-api-reference/soap-api-6.0/api-requests/proposal-microservice.md).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.2checkout.com/soap-api-reference/soap-api-6.0/api-requests/update-proposal.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
